stages:
  - security
  - test
sast:
  stage: security
include:
  - template: Security/SAST.gitlab-ci.yml

image: docker-registry.wikimedia.org/nodejs14-slim:latest
services:
  - name: docker-registry.wikimedia.org/memcached:latest
    alias: memcached
    entrypoint:
      - "/bin/bash"
      - "-c"
    command:
      - "memcached -l 0.0.0.0"
  - name: docker-registry.wikimedia.org/releng/cassandra311:latest
    alias: cassandra

unittests:
  stage: test
  variables:
    NODE_CACHING_BACKEND_CASS_HOST: '["cassandra"]'
    NODE_CACHING_BACKEND_MEMC_URI: "memcached:11211"
  script:
    - apt update
    - apt-get install -y wait-for-it python3-pip retry
    - pip install cqlsh
    - wait-for-it -h cassandra -p 9042
    - wait-for-it -h memcached -p 11211
    - retry -- cqlsh --execute "SHOW VERSION" cassandra
    - npm install
    - npm run test
linter:
  stage: test
  script:
    - npm install
    - npm run lint
codestyle:
  stage: test
  script:
    - npm install
    - npm run style
